unit untMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  EasyReg, StdCtrls, ExtCtrls, CheckLst, ComCtrls;

type
  TfrmDemo = class(TForm)
    StatusBar: TStatusBar;
    pgcDemo: TPageControl;
    tshGeneral: TTabSheet;
    tshNew: TTabSheet;
    Label5: TLabel;
    edtApplication: TEdit;
    tshCheck: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    btnCheck: TButton;
    edtCheckKey: TEdit;
    edtCheckName: TEdit;
    rgpCheckLocation: TRadioGroup;
    edtCheckLicense: TEdit;
    clbCheckOptions: TCheckListBox;
    btnNew: TButton;
    Label8: TLabel;
    Label9: TLabel;
    Label12: TLabel;
    edtNewKey: TEdit;
    edtNewName: TEdit;
    edtNewLicense: TEdit;
    clbNewOptions: TCheckListBox;
    rgpNewLocation: TRadioGroup;
    Label7: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    dtpNewDate: TDateTimePicker;
    Label15: TLabel;
    tshDummy: TTabSheet;
    btnDummy: TButton;
    Label16: TLabel;
    edtDummyKey: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    edtNewDummy: TEdit;
    Label19: TLabel;
    memManual: TMemo;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Label10: TLabel;
    edtCompany: TEdit;
    Label11: TLabel;
    edtProduct: TEdit;
    Label3: TLabel;
    edtVersion: TEdit;
    EasyReg: TEasyReg;
    Label20: TLabel;
    edtCheckVersion: TEdit;
    edtCheckDate: TEdit;
    Label4: TLabel;
    edtSequence: TEdit;
    {-- Form methods --}
    procedure FormCreate(Sender: TObject);
    {-- General tab ---}
    procedure edtApplicationExit(Sender: TObject);
    procedure edtVersionExit(Sender: TObject);
    procedure edtCompanyExit(Sender: TObject);
    procedure edtProductExit(Sender: TObject);
    procedure edtSequenceExit(Sender: TObject);
    {-- Dummy tab -----}
    procedure btnDummyClick(Sender: TObject);
    {-- New tab -------}
    procedure btnNewClick(Sender: TObject);
    procedure edtNewLicenseExit(Sender: TObject);
    {-- Check tab -----}
    procedure btnCheckClick(Sender: TObject);
    procedure rgpCheckLocationClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo: TfrmDemo;

implementation

{$R *.DFM}

{-- Form methods --------------------------------------------------------------}

procedure TfrmDemo.FormCreate(Sender: TObject);
var
  i : Integer;
begin
  i := SizeOf(TERName) - 1;
  edtCompany.MaxLength   := i;
  edtProduct.MaxLength   := i;
  edtNewName.MaxLength   := i;
  edtCheckName.MaxLength := i;

  EasyReg.Product            := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
  edtApplication.Text        := IntToStr(EasyReg.ApplicationID);
  edtVersion.Text            := IntToStr(EasyReg.Version);
  edtCompany.Text            := EasyReg.Company;
  edtProduct.Text            := EasyReg.Product;
  edtSequence.Text           := EasyReg.Sequence;
  rgpNewLocation.ItemIndex   := Ord(EasyReg.KeyLocation);
  dtpNewDate.Date            := Date + 30;
  rgpCheckLocation.ItemIndex := Ord(EasyReg.KeyLocation);
  rgpCheckLocationClick(Sender);
  edtCheckDate.Text          := DateToStr(Date);
  for i := Low(TEROptions) to High(TEROptions) do
    begin
      clbNewOptions.Items.Add(IntToStr(i));
      clbCheckOptions.Items.Add(IntToStr(i));
    end;
end;

{-- General tab ---------------------------------------------------------------}

procedure TfrmDemo.edtApplicationExit(Sender: TObject);
var
  iApp : Integer;
begin
  try
    iApp := StrToInt(edtApplication.Text);
    if (iApp < 0) or (iApp > MAXWORD) then
      raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d', [iApp, 0, MAXWORD]);
    EasyReg.ApplicationID := LoWord(iApp);
  except
    edtApplication.Text := IntToStr(EasyReg.ApplicationID);
  end;
end;

procedure TfrmDemo.edtVersionExit(Sender: TObject);
var
  iVer : integer;
begin
  try
    iVer := StrToInt(edtVersion.Text);
    if (iVer < 0) or (iVer > MAXBYTE) then
      raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d', [iVer, 0, MAXBYTE]);
    EasyReg.Version := LoByte(LoWord(iVer));
  except
    edtVersion.Text := IntToStr(EasyReg.Version);
  end;
end;

procedure TfrmDemo.edtCompanyExit(Sender: TObject);
begin
  EasyReg.Company := edtCompany.Text;
end;

procedure TfrmDemo.edtProductExit(Sender: TObject);
begin
  EasyReg.Product := edtProduct.Text;
end;

procedure TfrmDemo.edtSequenceExit(Sender: TObject);
begin
  EasyReg.Sequence := edtSequence.Text;
end;

{-- Dummy tab -----------------------------------------------------------------}

procedure TfrmDemo.btnDummyClick(Sender: TObject);
begin
  with EasyReg do
    begin
      EasyReg.Version      := StrToInt(edtVersion.Text);
      edtDummyKey.Text     := NewDummy;
      Statusbar.SimpleText := Format('%d = %s', [ErrorNumber, ErrorString]);
    end;
end;

{-- New tab -------------------------------------------------------------------}

procedure TfrmDemo.btnNewClick(Sender: TObject);
var
  i : Integer;
begin
  Statusbar.SimpleText := '';
  with EasyReg do
    begin
      KeyLocation          := TERKeyLocation(rgpNewLocation.ItemIndex);
      Version              := StrToInt(edtVersion.Text);
      LicenseID            := StrToInt(edtNewLicense.Text);
      LicenseDate          := dtpNewDate.DateTime;
      LicenseName          := edtNewName.Text;
      for i := Low(TEROptions) to High(TEROptions) do
        LicenseOptions[i] := clbNewOptions.Checked[i];
      NewKey(edtNewDummy.Text);
      edtNewKey.Text       := LicenseKey;
      Statusbar.SimpleText := Format('%d = %s', [ErrorNumber, ErrorString]);
    end;
end;

procedure TfrmDemo.edtNewLicenseExit(Sender: TObject);
var
  sLicenseID : String;
begin
  sLicenseID := edtNewLicense.Text;
  try
    edtNewLicense.Text := IntToStr(StrToInt(edtNewLicense.Text));
  except
    edtNewLicense.Text := sLicenseID;
  end;
end;

{-- Check tab -----------------------------------------------------------------}

procedure TfrmDemo.btnCheckClick(Sender: TObject);
var
  i : Integer;
begin
  Statusbar.SimpleText := '';
  with EasyReg do
    begin
      KeyLocation           := TERKeyLocation(rgpCheckLocation.ItemIndex);
      LicenseKey            := edtCheckKey.Text;
      LicenseName           := edtCheckName.Text;
      CheckKey;
      edtCheckVersion.Text  := IntToStr(Version);
      edtCheckLicense.Text  := IntToStr(LicenseID);
      edtCheckDate.Text     := DateToStr(LicenseDate);
      edtCheckKey.Text      := LicenseKey;
      edtCheckName.Text     := LicenseName;
      for i := Low(TEROptions) to High(TEROptions) do
        clbCheckOptions.Checked[i] := LicenseOptions[i];
      Statusbar.SimpleText := Format('%d = %s', [ErrorNumber, ErrorString]);
    end;
end;

procedure TfrmDemo.rgpCheckLocationClick(Sender: TObject);
begin
  edtCheckKey.ReadOnly  := (TERKeyLocation(rgpCheckLocation.ItemIndex) <> erManual);
  edtCheckName.ReadOnly := (TERKeyLocation(rgpCheckLocation.ItemIndex) <> erManual);
  with edtCheckKey  do if ReadOnly then Color := clGray else Color := clWindow;
  with edtCheckName do if ReadOnly then Color := clGray else Color := clWindow;
  with edtCheckKey  do if ReadOnly then Font.Color := clWhite else Font.Color := clBlack;
  with edtCheckName do if ReadOnly then Font.Color := clWhite else Font.Color := clBlack;
end;

end.
 